/*
Copyright (c) 2010-2011 The Regents of the University of California. All rights
reserved.

Permission is hereby granted, without written agreement and without license or 
royalty fees, to use, copy, modify, and distribute this software and its 
documentation for any purpose, provided that the above copyright notice and the
following two paragraphs appear in all copies of this software.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF 
CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING,
BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
*/

/*
 * @file main.h
*  Example program that demonstrates how to interface the PTP protocol with the
 * uIP protocol stack @link {http://www.sics.se/~adam/uip/index.php/Main_Page} 
 * and run the PTP protocol on the SH7216 Demonstration Kit containing the 
 * DP83640 Precision PHYTER. Program is just for demonstration.
 *
 * @author Michael Zimmer (mzimmer@eecs.berkeley.edu)
 * @version $Id: example.h 48 2011-04-09 00:05:32Z mzimmer $
 */

#include "ptp-protocol.h"

// uIP.
#define SRC_MAC {{0x00, 0x30, 0x55, 0x07, 0x01, 0x77}} //{{0x00, 0x30, 0x55, 0x07, 0x01, 0x6D}}
#define DEST_MAC {{0x01, 0x00, 0x5E, 0x00, 0x01, 0x81}} //{{0x01, 0x1B, 0x19, 0x00, 0x00, 0x00}};
#define SRC_IP {0xC0A8, 0x0067} //192, 168, 1, 103 (67)
#define MULTICAST_IP {0xE000, 0x0181} //224.0.1.129
#define LOCAL_EVENT_PORT 2049
#define LOCAL_GENERAL_PORT 2048

void ptp_init(void);
void add_ptp_hdr(void);

// Event scheduler.
void checkEventQueue();
UInteger8 timestampLess(const Timestamp *x, const Timestamp *y);
typedef struct EventInList {
	Event event;
	struct EventInList *nextEventInList;
} EventInList;
void addToEventQueue(Event *event);
void fixTimestampsInEventQueue(const TimeInterval *timeInterval);



