/*
Copyright (c) 2010-2011 The Regents of the University of California. All rights
reserved.

Permission is hereby granted, without written agreement and without license or 
royalty fees, to use, copy, modify, and distribute this software and its 
documentation for any purpose, provided that the above copyright notice and the
following two paragraphs appear in all copies of this software.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF 
CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING,
BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
*/

/**
 * @file ptp-platform-data-types.h
 * Define all platform dependent data types that are required
 * for the correct operation of PTP (5.2).
 *
 * @author Michael Zimmer (mzimmer@eecs.berkeley.edu)
 * @version $Id$
 */

#define TRUE (1) /**< TRUE. */
#define FALSE (0) /**< FALSE. */
#define NULL (0) /**< NULL. */

typedef unsigned char Boolean; /**< TRUE or FALSE. */
typedef unsigned char Enumeration4; /**< 4-bit enumerated value. */
typedef unsigned char Enumeration8; /**< 8-bit enumerated value. */
typedef unsigned short Enumeration16; /**< 16-bit enumerated value. */
typedef unsigned char UInteger4; /**< 4-bit signed integer. */
typedef signed char Integer8; /**< 8-bit signed integer. */
typedef unsigned char UInteger8; /**< 8-bit unsigned integer. */
typedef signed short Integer16; /**< 16-bit signed integer. */
typedef unsigned short UInteger16; /**< 16-bit unsigned integer. */
typedef signed int Integer32; /**< 32-bit signed integer. */
typedef unsigned int UInteger32; /**< 32-bit unsigned integer. */
/** 48-bit unsigned integer. */
typedef struct { 
    unsigned short msb; /**< 16-bit unsigned for upper 16 bits. */
    unsigned int lsb; /**< 32-bit unsigned for lower 32 bits. */
} UInteger48;
typedef signed long long Integer64; /**< 64-bit signed integer. */
typedef unsigned long long UInteger64; /**< 64-bit unsigned integer. */
typedef unsigned char Nibble; /**< 4-bit field not interpreted as a number. */
typedef char Octet; /**< 8-bit field not interpreted as a number. */
